
Foreman - Bug #16577

String::to_gb fails to parse "0 Bytes"

09/16/2016 05:49 AM - Brandon Weeks

Status: Closed   

Priority: Normal   

Assignee: Marek Hulán   

Category: Statistics   

Target version: 1.13.0   

Difficulty: trivial Fixed in Releases:  

Triaged:  Found in Releases: 1.13.0

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3854

  

Description

On some Ubuntu 14.04 boxes with swap disabled facter returns a value of "0 bytes" for the swapfree fact. This is unparseable by

String::to_gb which causes /statistics to show an error.

weeks@host:~$ facter swapfree

0 bytes

weeks@host:~$

Related issues:

Related to Foreman - Bug #2314: Smaller grains for VM memory/RAM choice needed Closed 03/13/2013

Associated revisions

Revision 0771cec2 - 09/22/2016 04:43 AM - Marek Hulán

Fixes #16577 - enhance unit detection

Revision a0c79911 - 09/26/2016 07:39 AM - Marek Hulán

Fixes #16577 - enhance unit detection

(cherry picked from commit 0771cec2351c75514abaf1c7040cdd5b74e8ef1d)

History

#1 - 09/16/2016 06:21 AM - Marek Hulán

Do you by any chance have a back trace or error message? That would help to debug.

#2 - 09/16/2016 06:25 AM - Brandon Weeks

- File backtrace.txt added

Attached!

Minimized test case:

"0 bytes".to_gb

#3 - 09/16/2016 06:59 AM - Marek Hulán

- Status changed from New to Assigned

- Assignee set to Marek Hulán

- translation missing: en.field_release set to 160

Thanks for the trace, that helped me. It's partly caused by #2314 and partly because we don't recognize Bytes as a unit. Also we have generic rescue

which hides the real cause. The fix should be easy.
https://projects.theforeman.org/issues/2314


#4 - 09/16/2016 07:11 AM - Marek Hulán

- Related to Bug #2314: Smaller grains for VM memory/RAM choice needed added

#5 - 09/16/2016 07:23 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3854 added

#6 - 09/16/2016 07:28 AM - Dominic Cleal

- translation missing: en.field_release deleted (160)

I don't think this was introduced in 1.13.0/#2314. 

https://github.com/theforeman/foreman/commit/eabbbeb4730abb51de2de8f9b302d26b14d6d33a#diff-54b2b2f744ded63c7d44629102bde356 only

seems to change how the units are scaled.

#7 - 09/16/2016 10:18 AM - Marek Hulán

There are two parts of this bug. First is thta "Bytes" are not recognized as unit. Second is that the Foreman::SIZE was removed but remained on line

which is triggered in this case. If we only fix matching, it will still fail for "0 Bytes" string because of this. If you prefer I can split this into 2 PRs, second

would be only replacing the Foreman::SIZE so it would be safe to get it into 1.13.

#8 - 09/22/2016 05:02 AM - Marek Hulán

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 0771cec2351c75514abaf1c7040cdd5b74e8ef1d.

#9 - 09/22/2016 07:05 AM - Dominic Cleal

- translation missing: en.field_release set to 160

Files

backtrace.txt 24.1 KB 09/16/2016 Brandon Weeks
